// CAdressverwaltungView.cpp : Implementierung der Klasse CAdressverwaltungView
//

#include "stdafx.h"
#include "Adressverwaltung.h"

#include "CAdressverwaltungDoc.h"
#include "CAdressverwaltungView.h"
#include "DialogAdresseBearbeiten.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAdressverwaltungView

IMPLEMENT_DYNCREATE(CAdressverwaltungView, CFormView)

BEGIN_MESSAGE_MAP(CAdressverwaltungView, CFormView)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_ADRESSEN, &CAdressverwaltungView::OnLvnItemchangedListAdressen)
	ON_BN_CLICKED(IDC_BUTTON_NEU, &CAdressverwaltungView::OnBnClickedButtonNeu)
	ON_BN_CLICKED(IDC_BUTTON_BEARBEITEN, &CAdressverwaltungView::OnBnClickedButtonBearbeiten)
END_MESSAGE_MAP()

// CAdressverwaltungView-Erstellung/Zerstrung

CAdressverwaltungView::CAdressverwaltungView()
	: CFormView(CAdressverwaltungView::IDD)
{
	// TODO: Hier Code zur Konstruktion einfgen

}

CAdressverwaltungView::~CAdressverwaltungView()
{
}

void CAdressverwaltungView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_ADRESSEN, m_ListCtrl);
}

BOOL CAdressverwaltungView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.

	return CFormView::PreCreateWindow(cs);
}

void CAdressverwaltungView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

}


// CAdressverwaltungView-Diagnose

#ifdef _DEBUG
void CAdressverwaltungView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAdressverwaltungView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CAdressverwaltungDoc* CAdressverwaltungView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAdressverwaltungDoc)));
	return (CAdressverwaltungDoc*)m_pDocument;
}
#endif //_DEBUG


// CAdressverwaltungView-Meldungshandler

void CAdressverwaltungView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
	// TODO: Fgen Sie hier Ihren spezialisierten Code ein, und/oder rufen Sie die Basisklasse auf.

	//ListControl befllen:

	//Beim allerersten Befllen die Spalten erzeugen:
	if (this->m_ListCtrl.GetHeaderCtrl()->GetItemCount() == 0)
	{
		this->m_ListCtrl.InsertColumn (0, _T("Name"), LVCFMT_LEFT, 100, -1);
		this->m_ListCtrl.InsertColumn (1, _T("Vorname"), LVCFMT_LEFT, 100, 1); //Verknpfen mit SubItem-Index 1
	}
	this->m_ListCtrl.DeleteAllItems();
	
	//1. Zeile:
	CString sNachname = _T("Mller");
	this->m_ListCtrl.InsertItem (0, sNachname);
	//SubItem in 2. Spalte:
	CString sVorname = _T("Otto");
	this->m_ListCtrl.SetItemText (0, 1, sVorname);

	//2. Zeile:
	sNachname = _T("Huber");
	this->m_ListCtrl.InsertItem (1, sNachname);
	sVorname = _T("Heinz");
	this->m_ListCtrl.SetItemText (1, 1, sVorname);

}

void CAdressverwaltungView::OnLvnItemchangedListAdressen(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	if ((pNMLV->uNewState & LVIS_SELECTED) == LVIS_SELECTED)
	{
		CString sMessage;
		sMessage.Format (_T("OnLvnItemchangedList  for item %d! "), pNMLV->iItem);
		AfxMessageBox ( sMessage);
	}

	*pResult = 0;
}

void CAdressverwaltungView::OnBnClickedButtonNeu()
{
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	CDialogAdresseBearbeiten dialogAdresse;
	if (dialogAdresse.DoModal() != IDOK)
		return;
}

void CAdressverwaltungView::OnBnClickedButtonBearbeiten()
{
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.

	//Index des gewhlten Items abrufen:
	POSITION posFirstSelected = this->m_ListCtrl.GetFirstSelectedItemPosition ();
	//Wenn es kein Item gibt dann kommt hier NULL zurck:
	if (posFirstSelected == NULL)
	{
		AfxMessageBox (_T("Kein Item gewhlt !"));
		return;
	}
	//Die erste gewhlte Adresse holen:
	int iItemSelected = this->m_ListCtrl.GetNextSelectedItem (posFirstSelected);
	CString sMessage;
	sMessage.Format (_T("Sie bearbeiten die Adresse in Zeile %d! "), iItemSelected);
	AfxMessageBox ( sMessage);


	CDialogAdresseBearbeiten dialogAdresse;
	if (dialogAdresse.DoModal() != IDOK)
		return;
}
